/*
 * Copyright 2024 the original author or authors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package xyz.zhouxy.plusone.oss;

import javax.annotation.Nonnull;

import xyz.zhouxy.plusone.commons.base.IWithCode;

/**
 *
 *
 * <p>
 *
 * </p>
 *
 * <p>
 * <b>NOTE: </b>
 * </p>
 * @author <a href="http://zhouxy.xyz:3000/ZhouXY108}">ZhouXY</a>
 */
public enum Protocol implements IWithCode<String> {
    HTTP("http"),
    HTTPS("https"),

    ;

    @Nonnull
    final String code;

    static final Protocol[] values = { HTTP, HTTPS };

    Protocol(@Nonnull String code) {
        this.code = code;
    }

    public static Protocol of(String code) {
        for (Protocol protocol : values) {
            if (protocol.equalsCode(code)) {
                return protocol;
            }
        }
        throw new IllegalArgumentException("Endpoint 中使用了无效的协议");
    }

    /**
     * @return the code
     */
    @Override
    @Nonnull
    public String getCode() {
        return code;
    }
}
